-- Code of Figure 14.12, page 659 from
-- Kenneth C. Louden, Programming Languages
-- Principles and Practice 2nd Edition
-- Copyright (C) Brooks-Cole/ITP, 2003
-- Parallel Integer Matrix Multiplication 
-- Package Specification

generic Size: INTEGER;
package IntMatrices is
  type IntMatrix is array (1..Size,1..Size) OF INTEGER;
  function ParMult(a,b: in IntMatrix) return IntMatrix;
end;
